package HTML_CodeSniffer::Plugin;
use strict;

sub edit_template {
    my ( $cb, $app, $tmpl ) = @_;
    return 0 unless MT->component( 'PowerCMS' );
    my $param = {};
    my $plugin = MT->component( 'HTML_CodeSniffer' );
    my $controls = File::Spec->catfile( $plugin->path, 'tmpl', 'html_codesniffer_controls.tmpl' );
    my $build = $app->build_page( $controls, $param );
    my $search = quotemeta( '<__trans phrase="Preview"></button>' );
    $$tmpl =~ s/($search)/$1 $build/s;
}

sub preview_template {
    my ( $cb, $app, $preview_tmpl, $data ) = @_;
    return 0 unless MT->component( 'PowerCMS' );
    if ( $app->mode ne 'preview_template' ) {
        return;
    }
    if ( $app->param( '__html_codesniffer' ) ) {
        my $blog = $app->blog;
        if (! $blog ) {
            return;
        }
        my $type = $preview_tmpl->type;
        my $tmpl = $preview_tmpl->clone_all();
        $tmpl->context( $preview_tmpl->context );
        my $ctx = $tmpl->context;
        $ctx->var( 'preview_template', 1 );
        my $html = $tmpl->build();
        if ( $html =~ m/<\/body>/i ) {
            my $plugin = MT->component( 'HTML_CodeSniffer' );
            my $lang = 'en';
            my $user_language = $app->user->preferred_language;
            my $filename = 'HTMLCS.js';
            if ( $user_language == 'ja' ) {
                $lang = 'ja';
                $filename = 'HTMLCS.ja.js';
            }
            my $level = $plugin->get_config_value( 'html_codesniffer_level', 'blog:' . $blog->id );
            my $param = {};
            $param->{ filename } = $filename;
            $param->{ language } = $lang;
            $param->{ level } = $level;
            my $js = File::Spec->catfile( $plugin->path, 'tmpl', 'html_codesniffer.tmpl' );
            my $build = $app->build_page( $js, $param );
            $html =~ s!(</body>)!$build $1!gsi;
        }
        $preview_tmpl->text( $html );
    }
}

1;
